5 export IFS
="$(printf "\n\b")"
7 MASTER_KEYRING
='&keyring-master-filename;'
8 eval "$(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)"
9 ARCHIVE_KEYRING
='&keyring-filename;'
10 eval "$(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)"
11 REMOVED_KEYS
='&keyring-removed-filename;'
12 eval "$(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)"
13 ARCHIVE_KEYRING_URI
='&keyring-uri;'
14 eval "$(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)"
16 aptkey_echo
() { echo "$@"; }
19 if [ "$(id -u)" -ne 0 ]; then
20 echo >&2 "ERROR: This command can only be used by root."
26 # command -v "$1" >/dev/null 2>&1 # not required by policy, see #747320
27 # which "$1" >/dev/null 2>&1 # is in debianutils (essential) but not on non-debian systems
31 if [ -x "${p}/${1}" ]; then
41 echo "$@" | sed -e "s#'#'\"'\"'#g"
44 get_fingerprints_of_keyring
() {
45 aptkey_execute
"$GPG_SH" --keyring "$1" --with-colons --fingerprint | while read publine
; do
46 # search for a public key
47 if [ "${publine%%:*}" != 'pub' ]; then continue; fi
48 # search for the associated fingerprint (should be the very next line)
49 while read fprline
; do
50 if [ "${fprline%%:*}" = 'sub' ]; then break; # should never happen
51 elif [ "${fprline%%:*}" != 'fpr' ]; then continue; fi
52 echo "$fprline" | cut
-d':' -f 10
54 # order in the keyring shouldn't be important
58 add_keys_with_verify_against_master_keyring
() {
62 if [ ! -f "$ADD_KEYRING" ]; then
63 echo >&2 "ERROR: '$ADD_KEYRING' not found"
66 if [ ! -f "$MASTER" ]; then
67 echo >&2 "ERROR: '$MASTER' not found"
71 # when adding new keys, make sure that the archive-master-keyring
73 # all keys that are exported must have a valid signature
74 # from a key in the $distro-master-keyring
75 add_keys
="$(get_fingerprints_of_keyring "$ADD_KEYRING")"
76 all_add_keys
="$(aptkey_execute "$GPG_SH" --keyring "$ADD_KEYRING" --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5)"
77 master_keys
="$(aptkey_execute "$GPG_SH" --keyring "$MASTER" --with-colons --list-keys | grep ^pub | cut -d: -f5)"
79 # ensure there are no colisions LP: #857472
80 for all_add_key
in $all_add_keys; do
81 for master_key
in $master_keys; do
82 if [ "$all_add_key" = "$master_key" ]; then
83 echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted"
89 for add_key
in $add_keys; do
90 # export the add keyring one-by-one
91 local TMP_KEYRING
="${GPGHOMEDIR}/tmp-keyring.gpg"
92 aptkey_execute
"$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --output "$TMP_KEYRING" --export "$add_key"
93 if ! aptkey_execute
"$GPG_SH" --batch --yes --keyring "$TMP_KEYRING" --import "$MASTER" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
94 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
97 # check if signed with the master key and only add in this case
99 for master_key
in $master_keys; do
100 if aptkey_execute
"$GPG_SH" --keyring "$TMP_KEYRING" --check-sigs --with-colons "$add_key" \
101 | grep '^sig:!:' | cut
-d: -f5 | grep -q "$master_key"; then
102 aptkey_execute
"$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --export "$add_key" \
103 | aptkey_execute
"$GPG" --batch --yes --import
107 if [ $ADDED = 0 ]; then
108 echo >&2 "Key '$add_key' not added. It is not signed with a master key"
110 rm -f "${TMP_KEYRING}"
114 # update the current archive signing keyring from a network URI
115 # the archive-keyring keys needs to be signed with the master key
116 # (otherwise it does not make sense from a security POV)
119 eval $(apt-config shell APT_DIR Dir)
121 # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128))
122 APT_KEY_NET_UPDATE_ENABLED
=""
123 eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled)
124 if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then
128 if [ -z "$ARCHIVE_KEYRING_URI" ]; then
129 echo >&2 "ERROR: Your distribution is not supported in net-update as no uri for the archive-keyring is set"
132 # in theory we would need to depend on wget for this, but this feature
133 # isn't useable in debian anyway as we have no keyring uri nor a master key
134 if ! command_available
'wget'; then
135 echo >&2 "ERROR: an installed wget is required for a network-based update"
138 if [ ! -d "${APT_DIR}/var/lib/apt/keyrings" ]; then
139 mkdir -p "${APT_DIR}/var/lib/apt/keyrings"
141 keyring
="${APT_DIR}/var/lib/apt/keyrings/$(basename "$ARCHIVE_KEYRING_URI")"
143 if [ -e $keyring ]; then
144 old_mtime
=$(stat -c %Y "$keyring")
146 (cd "${APT_DIR}/var/lib/apt/keyrings"; wget
--timeout=90 -q -N "$ARCHIVE_KEYRING_URI")
147 if [ ! -e "$keyring" ]; then
150 new_mtime
=$(stat -c %Y "$keyring")
151 if [ $new_mtime -ne $old_mtime ]; then
152 aptkey_echo
"Checking for new archive signing keys now"
153 add_keys_with_verify_against_master_keyring
"$keyring" "$MASTER_KEYRING"
158 if [ ! -f "$ARCHIVE_KEYRING" ]; then
159 echo >&2 "ERROR: Can't find the archive-keyring"
160 echo >&2 "Is the &keyring-package; package installed?"
164 # add new keys from the package;
166 # we do not use add_keys_with_verify_against_master_keyring here,
167 # because "update" is run on regular package updates. A
168 # attacker might as well replace the master-archive-keyring file
169 # in the package and add his own keys. so this check wouldn't
170 # add any security. we *need* this check on net-update though
171 import_keyring_into_keyring
"$ARCHIVE_KEYRING" '' && cat "${GPGHOMEDIR}/gpgoutput.log"
173 if [ -r "$REMOVED_KEYS" ]; then
174 # remove no-longer supported/used keys
175 get_fingerprints_of_keyring
"$REMOVED_KEYS" | while read key
; do
176 foreach_keyring_do
'remove_key_from_keyring' "$key"
179 echo >&2 "Warning: removed keys keyring $REMOVED_KEYS missing or not readable"
183 remove_key_from_keyring
() {
184 local KEYRINGFILE
="$1"
186 # non-existent keyrings have by definition no keys
187 if [ ! -e "$KEYRINGFILE" ]; then
192 local FINGERPRINTS
="${GPGHOMEDIR}/keyringfile.keylst"
193 get_fingerprints_of_keyring
"$KEYRINGFILE" > "$FINGERPRINTS"
194 # check if the key is in this keyring
195 if ! grep -iq "^[0-9A-F]*${KEY}$" "$FINGERPRINTS"; then
198 if [ ! -w "$KEYRINGFILE" ]; then
199 echo >&2 "Key ${KEY} is in keyring ${KEYRINGFILE}, but can't be removed as it is read only."
202 # check if it is the only key in the keyring and if so remove the keyring altogether
203 if [ '1' = "$(uniq "$FINGERPRINTS" | wc -l)" ]; then
204 mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" # behave like gpg
207 # we can't just modify pointed to files as these might be in /usr or something
209 if [ -L "$KEYRINGFILE" ]; then
210 REALTARGET
="$(readlink -f "$KEYRINGFILE")"
211 mv -f "$KEYRINGFILE" "${KEYRINGFILE}.dpkg-tmp"
212 cp -a "$REALTARGET" "$KEYRINGFILE"
214 # delete the key from the keyring
215 aptkey_execute
"$GPG_SH" --keyring "$KEYRINGFILE" --batch --delete-keys --yes "$KEY"
216 if [ -n "$REALTARGET" ]; then
217 # the real backup is the old link, not the copy we made
218 mv -f "${KEYRINGFILE}.dpkg-tmp" "${KEYRINGFILE}~"
223 foreach_keyring_do
() {
226 # if a --keyring was given, just work on this one
227 if [ -n "$FORCED_KEYRING" ]; then
228 $ACTION "$FORCED_KEYRING" "$@"
230 # otherwise all known keyrings are up for inspection
231 if [ -s "$TRUSTEDFILE" ]; then
232 $ACTION "$TRUSTEDFILE" "$@"
234 local TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
235 eval "$(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)"
236 if [ -d "$TRUSTEDPARTS" ]; then
237 # strip / suffix as gpg will double-slash in that case (#665411)
238 local STRIPPED_TRUSTEDPARTS
="${TRUSTEDPARTS%/}"
239 if [ "${STRIPPED_TRUSTEDPARTS}/" = "$TRUSTEDPARTS" ]; then
240 TRUSTEDPARTS
="$STRIPPED_TRUSTEDPARTS"
242 for trusted
in $(find "$TRUSTEDPARTS" -mindepth 1 -maxdepth 1 -regex '^.*\.gpg$' | sort); do
243 if [ -s "$trusted" ]; then
244 $ACTION "$trusted" "$@"
251 run_cmd_on_keyring
() {
252 local KEYRINGFILE
="$1"
254 # fingerprint and co will fail if key isn't in this keyring
255 aptkey_execute
"$GPG_SH" --keyring "$KEYRINGFILE" --batch "$@" 2>/dev
/null
|| true
258 import_keyring_into_keyring
() {
259 local FROM
="${1:-${GPGHOMEDIR}/pubring.gpg}"
260 local TO
="${2:-${GPGHOMEDIR}/pubring.gpg}"
262 rm -f "${GPGHOMEDIR}/gpgoutput.log"
263 # the idea is simple: We take keys from one keyring and copy it to another
264 # we do this with so many checks in between to ensure that WE control the
265 # creation, so we know that the (potentially) created $TO keyring is a
266 # simple keyring rather than a keybox as gpg2 would create it which in turn
267 # can't be read by gpgv.
268 # BEWARE: This is designed more in the way to work with the current
269 # callers, than to have a well defined it would be easy to add new callers to.
270 if [ ! -s "$TO" ]; then
271 if [ -s "$FROM" ]; then
273 if ! aptkey_execute
"$GPG_SH" --keyring "$FROM" --export ${1:+"$1"} > "$TO" 2> "${GPGHOMEDIR}/gpgoutput.log"; then
274 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
280 create_new_keyring
"$TO"
283 create_new_keyring
"$TO"
285 elif [ -s "$FROM" ]; then
286 local EXPORTLIMIT
="$1"
287 if [ -n "$1$2" ]; then shift; fi
288 if ! aptkey_execute
"$GPG_SH" --keyring "$FROM" --export ${EXPORTLIMIT:+"$EXPORTLIMIT"} \
289 | aptkey_execute
"$GPG_SH" --keyring "$TO" --batch --import "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
290 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
296 merge_all_trusted_keyrings_into_pubring
() {
298 # foreach_keyring_do 'import_keys_from_keyring' "${GPGHOMEDIR}/pubring.gpg"
299 # but without using gpg, just cat and find
300 local PUBRING
="${GPGHOMEDIR}/pubring.gpg"
301 # if a --keyring was given, just use this one
302 if [ -n "$FORCED_KEYRING" ]; then
303 if [ -s "$FORCED_KEYRING" ]; then
304 cp --dereference "$FORCED_KEYRING" "$PUBRING"
307 # otherwise all known keyrings are merged
308 local TRUSTEDPARTS
="/etc/apt/trusted.gpg.d"
309 eval $(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)
310 if [ -d "$TRUSTEDPARTS" ]; then
311 # ignore errors mostly for non-existing $TRUSTEDFILE
313 cat "$TRUSTEDFILE" || true
314 for parts
in $(find -L "$TRUSTEDPARTS" -type f -name '*.gpg'); do
317 } > "$PUBRING" 2>/dev
/null
318 elif [ -s "$TRUSTEDFILE" ]; then
319 cp --dereference "$TRUSTEDFILE" "$PUBRING"
323 if [ ! -s "$PUBRING" ]; then
328 import_keys_from_keyring
() {
329 import_keyring_into_keyring
"$1" "$2"
332 merge_keys_into_keyrings
() {
333 import_keyring_into_keyring
"$2" "$1" '' --import-options 'merge-only'
336 merge_back_changes
() {
337 if [ -n "$FORCED_KEYRING" ]; then
338 # if the keyring was forced merge is already done
341 if [ -s "${GPGHOMEDIR}/pubring.gpg" ]; then
342 # merge all updated keys
343 foreach_keyring_do
'merge_keys_into_keyrings' "${GPGHOMEDIR}/pubring.gpg"
345 # look for keys which were added or removed
346 get_fingerprints_of_keyring
"${GPGHOMEDIR}/pubring.orig.gpg" > "${GPGHOMEDIR}/pubring.orig.keylst"
347 get_fingerprints_of_keyring
"${GPGHOMEDIR}/pubring.gpg" > "${GPGHOMEDIR}/pubring.keylst"
348 comm -3 "${GPGHOMEDIR}/pubring.keylst" "${GPGHOMEDIR}/pubring.orig.keylst" > "${GPGHOMEDIR}/pubring.diff"
349 # key isn't part of new keyring, so remove
350 cut
-f 2 "${GPGHOMEDIR}/pubring.diff" | while read key
; do
351 if [ -z "$key" ]; then continue; fi
352 foreach_keyring_do
'remove_key_from_keyring' "$key"
354 # key is only part of new keyring, so we need to import it
355 cut
-f 1 "${GPGHOMEDIR}/pubring.diff" | while read key
; do
356 if [ -z "$key" ]; then continue; fi
357 import_keyring_into_keyring
'' "$TRUSTEDFILE" "$key"
361 setup_merged_keyring
() {
362 if [ -n "$FORCED_KEYID" ]; then
363 merge_all_trusted_keyrings_into_pubring
364 FORCED_KEYRING
="${GPGHOMEDIR}/forcedkeyid.gpg"
365 TRUSTEDFILE
="${FORCED_KEYRING}"
367 exec sh '($(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
368 GPG
="${GPGHOMEDIR}/gpg.1.sh"
369 # ignore error as this "just" means we haven't found the forced keyid and the keyring will be empty
370 import_keyring_into_keyring
'' "$TRUSTEDFILE" "$FORCED_KEYID" || true
371 elif [ -z "$FORCED_KEYRING" ]; then
372 merge_all_trusted_keyrings_into_pubring
373 if [ -r "${GPGHOMEDIR}/pubring.gpg" ]; then
374 cp -a "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg"
376 touch "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg"
379 exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${GPGHOMEDIR}/pubring.gpg")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
380 GPG
="${GPGHOMEDIR}/gpg.1.sh"
382 create_new_keyring
"$TRUSTEDFILE"
384 exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh"
385 GPG
="${GPGHOMEDIR}/gpg.1.sh"
389 create_new_keyring
() {
390 # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead.
391 if ! [ -e "$TRUSTEDFILE" ]; then
392 if [ -w "$(dirname "$TRUSTEDFILE")" ]; then
393 touch -- "$TRUSTEDFILE"
394 chmod 0644 -- "$TRUSTEDFILE"
399 aptkey_execute
() { sh
"$@"; }
402 echo "Usage: apt-key [--keyring file] [command] [arguments]"
404 echo "Manage apt's list of trusted keys"
406 echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)"
407 echo " apt-key del <keyid> - remove the key <keyid>"
408 echo " apt-key export <keyid> - output the key <keyid>"
409 echo " apt-key exportall - output all trusted keys"
410 echo " apt-key update - update keys using the keyring package"
411 echo " apt-key net-update - update keys using the network"
412 echo " apt-key list - list keys"
413 echo " apt-key finger - list fingerprints"
414 echo " apt-key adv - pass advanced options to gpg (download key)"
416 echo "If no specific keyring file is given the command applies to all keyring files."
419 while [ -n "$1" ]; do
432 FORCED_SECRET_KEYRING
="$1"
435 merge_back_changes
() { true
; }
436 create_new_keyring
() { if [ ! -r "$FORCED_KEYRING" ]; then TRUSTEDFILE
='/dev/null'; FORCED_KEYRING
="$TRUSTEDFILE"; fi; }
439 requires_root
() { true
; }
442 aptkey_echo
() { true
; }
445 # some cmds like finger redirect stderr to /dev/null …
446 aptkey_execute
() { echo 'EXEC:' "$@"; sh
"$@"; }
449 # … other more complicated ones pipe gpg into gpg.
450 aptkey_execute
() { echo >&2 'EXEC:' "$@"; sh
"$@"; }
453 echo >&2 "Unknown option: $1"
462 if [ -z "$TRUSTEDFILE" ]; then
463 TRUSTEDFILE
="/etc/apt/trusted.gpg"
464 eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring)
465 eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f)
469 if [ -z "$command" ]; then
476 # gpg needs (in different versions more or less) files to function correctly,
477 # so we give it its own homedir and generate some valid content for it later on
478 if [ -n "$TMPDIR" ]; then
479 # tmpdir is a directory and current user has rwx access to it
480 # same tests as in apt-pkg/contrib/fileutl.cc GetTempDir()
481 if [ ! -d "$TMPDIR" ] || [ ! -r "$TMPDIR" ] || [ ! -w "$TMPDIR" ] || [ ! -x "$TMPDIR" ]; then
485 GPGHOMEDIR
="$(mktemp -d)"
486 CURRENTTRAP
="${CURRENTTRAP} rm -rf '$(escape_shell "${GPGHOMEDIR}")';"
487 trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
488 chmod 700 "$GPGHOMEDIR"
492 eval "$(apt-config shell GPG_EXE Apt::Key::gpgcommand)"
494 if [ -n "$GPG_EXE" ] && command_available
"$GPG_EXE"; then
496 elif command_available
'gpg'; then
498 elif command_available
'gpg2'; then
501 echo >&2 "Error: gnupg or gnupg2 do not seem to be installed,"
502 echo >&2 "Error: but apt-key requires gnupg or gnupg2 for this operation."
509 # create the trustdb with an (empty) dummy keyring
510 # older gpgs required it, newer gpgs even warn that it isn't needed,
511 # but require it nonetheless for some commands, so we just play safe
512 # here for the foreseeable future and create a dummy one
513 touch "${GPGHOMEDIR}/empty.gpg"
514 if ! "$GPG_EXE" --ignore-time-conflict --no-options --no-default-keyring \
515 --homedir "$GPGHOMEDIR" --quiet --check-trustdb --keyring "${GPGHOMEDIR}/empty.gpg" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
516 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
520 # now tell gpg that it shouldn't try to maintain this trustdb file
522 exec '$(escape_shell "${GPG_EXE}")' --ignore-time-conflict --no-options --no-default-keyring \\
523 --homedir '$(escape_shell "${GPGHOMEDIR}")' --no-auto-check-trustdb --trust-model always \"\$@\"" > "${GPGHOMEDIR}/gpg.0.sh"
524 GPG_SH
="${GPGHOMEDIR}/gpg.0.sh"
527 # We don't usually need a secret keyring, of course, but
528 # for advanced operations, we might really need a secret keyring after all
529 if [ -n "$FORCED_SECRET_KEYRING" ] && [ -r "$FORCED_SECRET_KEYRING" ]; then
530 if ! aptkey_execute
"$GPG" -v --batch --import "$FORCED_SECRET_KEYRING" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then
531 cat >&2 "${GPGHOMEDIR}/gpgoutput.log"
535 # and then, there are older versions of gpg which panic and implode
536 # if there isn't one available - and writeable for imports
537 # and even if not output is littered with the creation of a secring,
538 # so lets call import once to have it create what it wants in silence
539 echo -n | aptkey_execute
"$GPG" --batch --import >/dev
/null
2>&1 || true
543 if [ "$command" != 'help' ] && [ "$command" != 'verify' ]; then
551 aptkey_execute
"$GPG" --quiet --batch --import "$@"
557 foreach_keyring_do
'remove_key_from_keyring' "$@"
573 foreach_keyring_do
'run_cmd_on_keyring' --list-keys "$@"
576 foreach_keyring_do
'run_cmd_on_keyring' --fingerprint "$@"
579 merge_all_trusted_keyrings_into_pubring
580 aptkey_execute
"$GPG_SH" --keyring "${GPGHOMEDIR}/pubring.gpg" --armor --export "$@"
584 aptkey_echo
"Executing: $GPG $*"
585 aptkey_execute
"$GPG" "$@"
590 eval $(apt-config shell GPGV Apt::Key::gpgvcommand)
591 if [ -n "$GPGV" ] && command_available
"$GPGV"; then true
;
592 elif command_available
'gpgv'; then GPGV
='gpgv';
593 elif command_available
'gpgv2'; then GPGV
='gpgv2';
595 echo >&2 'ERROR: gpgv or gpgv2 required for verification'
598 # for a forced keyid we need gpg --export, so full wrapping required
599 if [ -n "$FORCED_KEYID" ]; then
605 if [ -n "$FORCED_KEYRING" ]; then
606 "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${FORCED_KEYRING}" --ignore-time-conflict "$@"
608 "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${GPGHOMEDIR}/pubring.gpg" --ignore-time-conflict "$@"